/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataGoogleBeyondcorpSecurityGatewayConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.36.0/docs/data-sources/google_beyondcorp_security_gateway#id DataGoogleBeyondcorpSecurityGateway#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.36.0/docs/data-sources/google_beyondcorp_security_gateway#project DataGoogleBeyondcorpSecurityGateway#project}
    */
    readonly project?: string;
    /**
    * Optional. User-settable SecurityGateway resource ID.
    * * Must start with a letter.
    * * Must contain between 4-63 characters from '/a-z-/'.
    * * Must end with a number or letter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.36.0/docs/data-sources/google_beyondcorp_security_gateway#security_gateway_id DataGoogleBeyondcorpSecurityGateway#security_gateway_id}
    */
    readonly securityGatewayId: string;
}
export interface DataGoogleBeyondcorpSecurityGatewayHubsInternetGateway {
}
export declare function dataGoogleBeyondcorpSecurityGatewayHubsInternetGatewayToTerraform(struct?: DataGoogleBeyondcorpSecurityGatewayHubsInternetGateway): any;
export declare function dataGoogleBeyondcorpSecurityGatewayHubsInternetGatewayToHclTerraform(struct?: DataGoogleBeyondcorpSecurityGatewayHubsInternetGateway): any;
export declare class DataGoogleBeyondcorpSecurityGatewayHubsInternetGatewayOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataGoogleBeyondcorpSecurityGatewayHubsInternetGateway | undefined;
    set internalValue(value: DataGoogleBeyondcorpSecurityGatewayHubsInternetGateway | undefined);
    get assignedIps(): string[];
}
export declare class DataGoogleBeyondcorpSecurityGatewayHubsInternetGatewayList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataGoogleBeyondcorpSecurityGatewayHubsInternetGatewayOutputReference;
}
export interface DataGoogleBeyondcorpSecurityGatewayHubs {
}
export declare function dataGoogleBeyondcorpSecurityGatewayHubsToTerraform(struct?: DataGoogleBeyondcorpSecurityGatewayHubs): any;
export declare function dataGoogleBeyondcorpSecurityGatewayHubsToHclTerraform(struct?: DataGoogleBeyondcorpSecurityGatewayHubs): any;
export declare class DataGoogleBeyondcorpSecurityGatewayHubsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataGoogleBeyondcorpSecurityGatewayHubs | undefined;
    set internalValue(value: DataGoogleBeyondcorpSecurityGatewayHubs | undefined);
    private _internetGateway;
    get internetGateway(): DataGoogleBeyondcorpSecurityGatewayHubsInternetGatewayList;
    get region(): string;
}
export declare class DataGoogleBeyondcorpSecurityGatewayHubsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataGoogleBeyondcorpSecurityGatewayHubsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.36.0/docs/data-sources/google_beyondcorp_security_gateway google_beyondcorp_security_gateway}
*/
export declare class DataGoogleBeyondcorpSecurityGateway extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "google_beyondcorp_security_gateway";
    /**
    * Generates CDKTF code for importing a DataGoogleBeyondcorpSecurityGateway resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataGoogleBeyondcorpSecurityGateway to import
    * @param importFromId The id of the existing DataGoogleBeyondcorpSecurityGateway that should be imported. Refer to the {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.36.0/docs/data-sources/google_beyondcorp_security_gateway#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataGoogleBeyondcorpSecurityGateway to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/hashicorp/google-beta/6.36.0/docs/data-sources/google_beyondcorp_security_gateway google_beyondcorp_security_gateway} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataGoogleBeyondcorpSecurityGatewayConfig
    */
    constructor(scope: Construct, id: string, config: DataGoogleBeyondcorpSecurityGatewayConfig);
    get createTime(): string;
    get displayName(): string;
    get externalIps(): string[];
    private _hubs;
    get hubs(): DataGoogleBeyondcorpSecurityGatewayHubsList;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get location(): string;
    get name(): string;
    private _project?;
    get project(): string;
    set project(value: string);
    resetProject(): void;
    get projectInput(): string | undefined;
    private _securityGatewayId?;
    get securityGatewayId(): string;
    set securityGatewayId(value: string);
    get securityGatewayIdInput(): string | undefined;
    get state(): string;
    get updateTime(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
